class Hex:
	#a generic Hex object w/ axial coordinates
	def __init__(self,q,r):
		self.q = q
		self.r = r
	def to_cube(self):
		x = self.q
		z = self.r
		y = -x-z
		return Cube(x,y,z)
				
class Cube:
	#a generic Cube object w/ cubic coordinates
	def __init__(self,x,y,z):
		self.x = x
		self.y = y
		self.z = z
	def to_hex(self):
		q = self.x
		r = self.z
		return Hex(q,r)	

def getEven(n):
	#return 1 if n is odd, or 0 if n is even
	m = n%2
	return m

def cube_round(c):
	e = 0.0000001	#seems to make lines 'straighter'?
	rx = round(c.x-e)
	ry = round(c.y-e)
	rz = round(c.z-e)
	
	x_diff = abs(rx - c.x)
	y_diff = abs(ry - c.y)
	z_diff = abs(rz - c.z)
	
	if x_diff > y_diff and x_diff > z_diff:
		rx = -ry-rz
	elif y_diff > z_diff:
		ry = -rx-rz
	else:
		rz = -rx-ry
	hex = Cube(rx,ry,rz).to_hex()
	
	cube = hex.to_cube()
	return cube
	
def cube_lerp(a,b,t):
	assert 0 <= t <= 1.0
	return Cube(a.x + (b.x - a.x) * t,
				a.y + (b.y - a.y) * t,
				a.z + (b.z - a.z) * t)
				
def cube_line(a,b):
	N = int(cube_distance(a,b))
	results = []
	
	for i in range(N):
		results.append(cube_round(cube_lerp(a, b, 1.0 / N*i)))
		
	return results
	
	
def cube_distance(a,b):
	dx = a.x - b.x
	dy = a.y - b.y
	dz = a.z - b.z
	return max(dx,dy,dz)

def cube_area_draw(h,r):
	c = h.to_cube()
	results = []
	
	x,y,z = c.x, c.y, c.z
	
	xmin = x - r
	xmax = x + r
	
	ymin = y - r
	ymax = y + r
	
	zmin = z - r
	zmax = z + r
	
	for x in range(xmin, xmax+1):
		for y in range(max(ymin, -x - zmax), min(ymax, -x - zmin)+1):
			z = -x-y
			results.append(Cube(x,y,z))
	return results
